//NOTE: This was part of the development stage of the Platformer Bricks pack. Please don't eat my organs for not changing the variable names.
$Platformer::Challenge::SpeedrunUpdate = 10;
$Platformer::Challenge::SpeedrunFloat = 2;
$Platformer::Challenge::SpeedrunTimeSep0 = "'";
$Platformer::Challenge::SpeedrunTimeSep1 = "\"";
$Platformer::Challenge::SpeedrunFile = "config/server/platformerspeedrun.txt";

function speedrunWrite(%race)
{
	warn("Writing speedrun record for" SPC %race @ "...");
	%store = new scriptObject();
	%file = new fileObject();
	%file.openForRead($Platformer::Challenge::SpeedrunFile);
	%i = 0;
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		%currace = getField(%line, 0);
		if(%currace $= %race)
			%store.skipLine = %i;
		%store.line[%i] = %line;
		%i++;
	}
	%file.close();

	%file.openForWrite($Platformer::Challenge::SpeedrunFile);
	for(%x = 0; %x < %i; %x++)
	{
		if(%store.skipLine !$= "" && %x == %store.skipLine)
			continue;
		%line = %store.line[%x];
		%file.writeLine(%line);
	}
	%file.writeLine(%race TAB $SpeedrunRecords_[%race] TAB $SpeedrunRecordHolders_[%race]);
	%file.close();
	%file.delete();
	//%store.dump();
	%store.delete();
}

function speedrunRead()
{
	warn("Reading speadrun records...");
	%file = new fileObject();
	%file.openForRead($Platformer::Challenge::SpeedrunFile);
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		%race = getField(%line, 0);
		%time = getField(%line, 1);
		%hold = getField(%line, 2);
		$SpeedrunRecords_[%race] = %time;
		$SpeedrunRecordHolders_[%race] = %hold;
	}
	%file.close();
	%file.delete();
}

if(isFile($Platformer::Challenge::SpeedrunFile))
	speedrunRead();

function formatSeconds(%time, %sep, %sep2)
{
	%sec = mFloor(%time);
	%ms = mFloatLength(%time - %sec, 2) * 100;
	%min = mFloor(%sec / 60);
	%dsec = %sec - (%min * 60);

	//quick simple lazy formatting because it fits our needs
	if(strLen(%dsec) == 1)
		%dsec = 0 @ %dsec;

	if(strLen(%min) == 1)
		%min = 0 @ %min;

	return %min @ %sep @ %dsec @ (%sep2 !$= "" ? %sep2 : %sep) @ %ms;
}

function Player::SpeedrunTick(%this)
{
	if(!isObject(%this.client))
		return;

	if(isEventPending(%this.speedrun))
		cancel(%this.speedrun);

	%sim = $Sim::Time;
	%diff = mFloatLength(%sim - %this.speedrunStart, $Platformer::Challenge::SpeedrunFloat);
	%time = formatSeconds(%diff, $Platformer::Challenge::SpeedrunTimeSep0, $Platformer::Challenge::SpeedrunTimeSep1);

	%race = (%this.speedrunName !$= "" ? %this.speedrunName : "Speedrun");

	if($SpeedrunRecords_[%this.speedrunName] != 999999)
	{
		%rtime = formatSeconds($SpeedrunRecords_[%this.speedrunName], $Platformer::Challenge::SpeedrunTimeSep0, $Platformer::Challenge::SpeedrunTimeSep1);
		%this.client.centerPrint("<font:verdana:20><just:right>\c3Record\c6: <br>\c6" @ %rtime @ " <br>\c3By\c6: <br>\c6" @ $SpeedrunRecordHolders_[%race] @ " ", 1);
	}

	%this.client.bottomPrint("<font:verdana:20><just:right>\c3" @ %race @ "\c6:<br>\c6" @ %time @ " ", 1, 1);

	%this.speedrun = %this.schedule($Platformer::Challenge::SpeedrunUpdate, SpeedrunTick);
}

function Player::SpeedrunStart(%this, %race)
{
	if(!isObject(%this.client))
		return;
	if(%this.isSpeedrunning)
	{
		if($Sim::Time - %this.speedrunStart > 5)
			%this.client.centerPrint("You already have an active speedrun.", 3);
		return;
	}

	%this.speedrunStart = $Sim::Time;
	%this.isSpeedrunning = true;
	%this.speedrunName = %race;

	if($SpeedrunRecords_[%race] <= 0)
		$SpeedrunRecords_[%race] = 999999;

	%this.SpeedrunTick();
}

function Player::SpeedrunEnd(%this, %record)
{
	if(isEventPending(%this.speedrun))
		cancel(%this.speedrun);

	if(!%this.isSpeedrunning)
		return;

	if(isObject(%this.client))
	{	
		%time = $Sim::Time - %this.speedrunStart;
		%dtime = formatSeconds(%time, $Platformer::Challenge::SpeedrunTimeSep0, $Platformer::Challenge::SpeedrunTimeSep1);

		%race = (%this.speedrunName !$= "" ? %this.speedrunName : "Speedrun");

		%this.client.bottomPrint("<font:verdana:20><just:right>\c3" @ %race @ "\c6:<br>\c2" @ %dtime @ " ", 3, 1);

		if(%record && %race !$= "Speedrun" && %time < $SpeedrunRecords_[%race])
		{
			$SpeedrunRecords_[%race] = %time;
			$SpeedrunRecordHolders_[%race] = %this.client.getPlayerName();
			messageAll('', "<font:verdana bold:20>\c3" @ %this.client.getPlayerName() @ "\c6 set a new record for \c3" @ %race @ "\c6! \c2(" @ %dtime @ ")");
			speedrunWrite(%race);
		}
	}
	%this.speedrunStart = "";
	%this.isSpeedrunning = false;
}

package Platformer_Speedrun
{
	function GameConnection::onDeath(%this, %obj, %killer, %damageType, %damageLoc)
	{
		if(isObject(%this.player))
		{
			if(%this.player.isSpeedrunning)
				%this.player.SpeedrunEnd();
		}
		parent::onDeath(%this, %obj, %killer, %damageType, %damageLoc);
	}

	function Player::onRemove(%this)
	{
		if(%this.isSpeedrunning)
			%this.SpeedrunEnd();
		parent::onRemove(%this);
	}
};
activatePackage(Platformer_Speedrun);

registerOutputEvent(Player, "SpeedrunStart", "string 200 200");
registerOutputEvent(Player, "SpeedrunEnd", "bool");